#!/bin/bash
. /usr/share/eole/FonctionsEoleNg
old=$1
new=$2
if [ "$old" == "" -o "$new" == "" ];then
	echo -e "\nScript de migration du nom de domaine de l'établissement\n"
	echo -e "usage : $0 anciendomaine nouveaudomaine\n"
	exit 1
fi
Question "Migrer de $1 vers $2"
if [ $? -ne 0 ];then
	echo "Abandon"
	exit 1
fi
oldsympa="/var/lib/sympa/expl/i-$old"
newsympa="/var/lib/sympa/expl/i-$new"
oldetc="/etc/sympa/i-$old"
newetc="/etc/sympa/i-$new"
ldif="/root/annuaire-`date +%Y%m%d`.ldif"
ldif2="/root/annuaire-`date +%Y%m%d`-2.ldif"
# vérifications préalables...
if [ ! -d $oldsympa ];then
	echo "Erreur : le répertoire $oldsympa n'existe pas !"
	exit 1
fi
if [ ! -d $oldetc ];then
	echo "Erreur : le répertoire $oldetc n'existe pas !"
	exit 1
fi
# le répertoire a pu être créé par reconfigure
#if [ -d $newetc ];then
#	echo "Erreur : le répertoire $newetc existe déjà !"
#	exit 1
#fi
if [ -d $newsympa ];then
	echo "Erreur : le répertoire $newsympa existe déjà !"
	exit 1
fi
if [ -f $ldif ];then
	echo "Erreur : Le fichier $ldif existe déjà !"
	exit 1
fi
echo "# Sauvegarde de l'annuaire dans $ldif..."
/etc/init.d/slapd stop
slapcat > $ldif
cp -f $ldif $ldif2
echo "# Modification de l'annuaire..."
sed -i "s/$old/$new/g" $ldif2
rm -f /var/lib/ldap/*.*
slapadd -l $ldif2
chown openldap:openldap /var/lib/ldap/*.*
/etc/init.d/slapd start
rm -f $ldif2
echo "# Migration des configurations sympa..."
mv $oldetc $newetc
mv $oldsympa $newsympa
for confsympa in `find /var/lib/sympa/expl -name config`;do
	sed -i "s/$old/$new/g" $confsympa
done
echo "# Migration des alias Exim4..."
sed -i "s/$old/$new/g" /etc/mail/sympa.aliases
sed -i "s/$old/$new/g" /etc/aliases
echo -e "\nMigration terminée : modifiez la variable \"Nom de domaine de la messagerie\""
echo -e "puis lancez la commande *reconfigure*\n"
exit 0
